#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

int
getmaster(char *devname)
{
    const char *p1;
    const char *p2;
    int fd;

    strcpy(devname, "/dev/pty  ");

    for (p1 = "pqrstuvwxyzPQRST"; *p1; ++p1) {
	devname[8] = *p1;
	for (p2 = "0123456789abcdef"; *p2; ++p2) {
	    devname[9] = *p2;
	    fd = open(devname, O_RDWR);
	    if (fd >= 0) {
		devname[5] = 't';
		return fd;
	    } else if (errno == ENOENT) {
		break;		/* Only inner loop */
	    }
	}
    }
    fprintf(stderr, "ule: out of ptys\n");
    exit(1);
}

int
getslave(const char *devname)
{
    int fd;

    fd = open(devname, O_RDWR);
    if (fd < 0) {
	fprintf(stderr, "ule: could not open slave pty %s: %s\n",
		devname, strerror(errno));
	exit(1);
    }

#ifdef TIOCSCTTY
    {
	int ttyfd;
	ttyfd = open("/dev/tty", O_RDWR);
	if (ttyfd < 0) {
	    /* No controlling tty, try to set it the BSD way. */
	    if (ioctl(fd, TIOCSCTTY, (char *)NULL) < 0) {
		perror("ule: iotcl(TIOCSCTTY)");
		exit(1);
	    }
	} else {
	    /* We already have a controlling tty, it must have been
               set by the open() above. */
	    close(ttyfd);
	}
    }
#endif
    
    return fd;
}
